package types

// Is returns true if the encountered type `a` can be converted into the expected type `b`.
func Is(a Type, b Type) bool {
	if a == nil {
		return true
	}

	if a == b {
		return true
	}

	aPointer, aIsPointer := a.(*Pointer)
	bPointer, bIsPointer := b.(*Pointer)

	if aIsPointer && bIsPointer && (bPointer.To == nil || aPointer.To == bPointer.To) {
		return true
	}

	aArray, aIsArray := a.(*Array)

	if aIsArray && bIsPointer && (bPointer.To == nil || aArray.Of == bPointer.To) {
		return true
	}

	bArray, bIsArray := b.(*Array)

	if aIsArray && bIsArray && aArray.Of == bArray.Of {
		return true
	}

	return false
}
